unit x;

interface

implementation

{_________________________________________________}

  procedure QuadraticRoots (var alpha: precisionVector;
                  var cartRoot: complexVector;
                  var polarRoot: polarVector);

    var
      discriminant, pi, radToDeg, numerator, denominator: real;

  begin
    pi := 4 * ArcTan(1.0);
    radToDeg := 180.0 / pi;

    cartRoot[1].im := 0;
    cartRoot[2].im := 0;
    discriminant := Sqr(alpha[1]) - 4 * alpha[0] * alpha[2];
    if (discriminant > 0) and (alpha[0] <> 0) then
      begin
        cartRoot[1].re := (-alpha[1] + Sqrt(discriminant)) / (2 * alpha[0]);
        cartRoot[2].re := (-alpha[1] - Sqrt(discriminant)) / (2 * alpha[0]);
      end;
    if (discriminant = 0) and (alpha[0] <> 0) then
      begin
        cartRoot[1].re := -alpha[1] / (2 * alpha[0]);
        cartRoot[2].re := cartRoot[1].re;
      end;

    polarRoot[1].modu := cartRoot[1].re;
    polarRoot[2].modu := cartRoot[2].re;
    polarRoot[1].argu := 0.0;
    polarRoot[2].argu := 0.0;

    if (discriminant < 0) and (alpha[0] <> 0) then
      begin
        cartRoot[1].re := -alpha[1] / (2 * alpha[0]);
        cartRoot[1].im := Sqrt(-discriminant) / (2 * alpha[0]);
        cartRoot[2].re := -alpha[1] / (2 * alpha[0]);
        cartRoot[2].im := cartRoot[1].im;

        polarRoot[1].modu := Sqrt(Sqr(cartRoot[1].re) + Sqr(cartRoot[1].im));
        polarRoot[2].modu := polarRoot[1].modu;

        if cartRoot[1].im > 0 then
          numerator := cartRoot[1].im
        else
          numerator := cartRoot[1].im;
        denominator := cartRoot[1].re;
        polarRoot[1].argu := Arctan(cartRoot[1].im / cartRoot[1].re);
        if denominator < 0 then
          polarRoot[1].argu := polarRoot[1].argu + pi;
        polarRoot[1].argu := polarRoot[1].argu * radToDeg;
        polarRoot[2].argu := -polarRoot[1].argu
      end;

  end; {QuadraticRoots}

{_________________________________________________}

